#! /usr/bin/perl
# スケジュールデータの入力フォーム
# P=xxxx    プリフィックス
# DATE=xxxx+xx+xx    年月日

$schdule_url    = "http://raspberrypi/cgi-bin/schedule/schedule.cgi";
$color_name_fg  = "#000000";
$color_name_bg  = "#F0FFF0";
$color_wday_fg  = "#000000";
$color_wday_bg  = "#F0F0F0";
$color_sat_fg   = "#FFFFFF";
$color_sat_bg   = "#0000FF";
$color_sun_fg   = "#FFFFFF";
$color_sun_bg   = "#FF0000";
$color_today_fg = "#000000";
$color_today_bg = "#FFFF80";
$width_date     = "30";
$width_schedule = "160";


###########################################################################
#パラメータの取り込み
$year = 0;
$mon = 0;
$mday = 0;
$prefix="";

if($ENV{QUERY_STRING} ne ""){
    @qs = split('&',$ENV{QUERY_STRING});
    foreach $each_qs(@qs){
        ($variable,$value) = split('=',$each_qs);
        if($variable eq "DATE"){
            ($year,$mon,$mday) = split('\+',$value);
        }elsif($variable eq "PFIX"){
            $prefix = $value;
        }
    }
}

###########################################################################
#メンバー表に指定されたプリフィックスが存在するかどうか

$flag=0;
open(MEMBER,"member.txt") || die "Open error :$!\n";
@memberlist=<MEMBER>;
close MEMBER;
foreach $eachmember(@memberlist){
    chomp($eachmember);                   #行末の改行の削除
    @rowdata=split(',',$eachmember);
    if(($rowdata[0] =~ /^\s*$/)||($rowdata[1] =~ /^\s*$/)){  #空白データが見つかったら終了
        last;
    }
    if($rowdata[1] eq $prefix){
        $username=$rowdata[0];
        $flag=1;
        last;
    }
}

###########################################################################
#メンバー表に指定されたプリフィックスが存在しなかった場合の処理
if($flag == 0){
print <<EOF;
content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="refresh" CONTENT="0;URL=$schdule_url">
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
</HEAD>
<BODY BGCOLOR="#FFFFFF">
パラメータ不正<A HREF="schedule.cgi">戻る</A><BR>
</BODY>
</HTML>
EOF

exit(0);
}



###########################################################################
#日付の設定

$year   =int($year);
$mon    =int($mon);
$mday   =int($mday);
$lastday = &getlastday($mon);

#指定された日付が不正な場合は当日の日付にする。
if($year<1999 || $year>2030 || $mon<1 || $mon>12 || $mday<1 || $mday >$lastday){
    $time=time;
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdaylight)=localtime($time);
    $mon +=1;
    $year +=1900;
}

#入力する最終日を設定
if(($mday + 6) < $lastday){
    $lastday = $mday + 6;
}

###########################################################################
#入力初日の曜日を求める(0:SUN 1:MON...)
#  localtime()が返す $wday だと、任意の年月の曜日が取得できないので
#  getweek()サブルーチンを使っている。
$wday = &getweek($year, $mon, $mday);
@weekday=("SUN","MON","TUE","WED","THU","FRI","SAT");


###########################################################################
#データの読み込み
@scheduledata;
$datfilename = sprintf("%s%04d%02d.txt",$prefix,$year,$mon);

if(open(DATFILE,$datfilename)){
    @dat=<DATFILE>;
    close DATFILE;
}

###########################################################################
#戻り先 CGIのURLの設定
$returntocgi = sprintf("schedule.cgi?DATE=%d+%d+99",$year,$mon);


###########################################################################
# HTMLの出力
print <<EOF;
content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<TITLE>Schedule Input form</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">

<FONT SIZE="+2"><B>$usernameさん<BR>$year年$mon月$mday日～$lastday日 スケジュール入力</B></FONT>
<BR>
<FORM METHOD="post" ACTION="savedat.cgi">
<INPUT TYPE="hidden" NAME="FILENAME" VALUE="$datfilename">
<TABLE BORDER="1" CELLSPACING="0">
EOF

$w = $wday;
for($d=$mday-1;$d < $lastday;$d++){
    # 日付セルの色設定
    if($w == 0){
        $col_d_fg = $color_sun_fg;
        $col_d_bg = $color_sun_bg;
    }elsif($w == 6){
        $col_d_fg = $color_sat_fg;
        $col_d_bg = $color_sat_bg;
    }else{
        $col_d_fg = $color_wday_fg;
        $col_d_bg = $color_wday_bg;
    }

    print("<TR>\n");
    printf("<TD ALIGN=\"CENTER\" bgcolor=\"%s\"><FONT color=\"%s\">",$col_d_bg,$col_d_fg);
    printf("<B>%d</B><BR><SMALL>%s</SMALL></TD>\n",$d+1,$weekday[$w]);
    
    printf ("<TD ALIGN=\"LEFT\">");
    printf ("<TEXTAREA cols=\"30\" rows=\"5\"  NAME=\"%d\">",$d+1);
    $celldata =$dat[$d];
    chomp($celldata);
    $celldata =~ s/&/&amp;/g;           #「&」を「&amp;」に置換
    $celldata =~ s/</&lt;/g;            #「<」を「&lt;」に置換
    $celldata =~ s/>/&gt;/g;            #「>」を「&gt;」に置換
    $celldata =~ s/\s/&nbsp;/g;         # 空白文字を「&nbsp;」に置換
    $celldata =~ s/\\\\/\a/g;           #「\\」をいったん「アラーム文字」に置換
    $celldata =~ s/\\n/\n/g;            #「\n」を「<BR>」に置換
    $celldata =~ s/\a/\\/g;             #「アラーム文字」を「\」に置換
    printf ("$celldata");
    printf ("</TEXTAREA>");
    printf ("</TD>\n");
    print "</TR>\n";

    $w++;
    if($w > 6){
        $w = 0;
    }
}

print <<EOF;
</TABLE>
&nbsp;&nbsp;<INPUT TYPE="submit" VALUE="保存">
<INPUT TYPE="reset" VALUE="リセット">
</FORM>
&nbsp;&nbsp;<A HREF="$returntocgi">何もせずにスケジュール一覧に戻る</A><BR>
</BODY>
</HTML>
EOF

exit(0);


###########################################################################
#その月の日数を求める
sub getlastday{
    my($month) =@_;
    $lastday = 31;
    if($month==2){
        if(($year % 400)==0){
            $lastday = 29;
        }elsif(($year % 100)==0){
            $lastday = 28;
        }elsif(($year % 4)==0){
            $lastday = 29;
        }else{
            $lastday = 28;
        }
    }elsif($month==4 || $month==6 ||$month==9 ||$month==11){
            $lastday = 30;
    }
    return($lastday);
}




##############################################################
# 月初の曜日を得る関数
# 下記 WEBページに掲載されていたものを使わせていただきました。
# http://www.tt.rim.or.jp/~canada/comp/cgi/tech/
sub getweek{
    my($year,$month,$day) = @_;
    if ($month == 1 || $month == 2) {
        $year--;
        $month += 12;
    }
    int(
          $year
        + int($year/4)
        - int($year/100)
        + int($year/400)
        + int((13*$month+8)/5)
        + $day
    ) % 7;
}

