#! /usr/bin/perl

$thiscginame    = "schedule.cgi";
$todaycginame   = "today.cgi";
$color_name_fg  = "#000000";
$color_name_bg  = "#F0FFF0";
$color_wday_fg  = "#000000";
$color_wday_bg  = "#F0F0F0";
$color_sat_fg   = "#FFFFFF";
$color_sat_bg   = "#0000FF";
$color_sun_fg   = "#FFFFFF";
$color_sun_bg   = "#FF0000";
$color_today_fg = "#000000";
$color_today_bg = "#FFFF80";
$width_date     = "30";
$width_schedule = "200";


###########################################################################
#表示月の設定
$variable = "";
$value = "";
$year = 0;
$mon = 0;
$mday = 0;

$time=time;
($sec,$min,$hour,$today,$thismon,$thisyear,$wday,$yday,$isdaylight)=localtime($time);
$thismon += 1;
$thisyear += 1900;


if($ENV{QUERY_STRING} ne ""){
    @qs = split('&',$ENV{QUERY_STRING});
    foreach $each_qs(@qs){
        ($variable,$value) = split('=',$each_qs);
        if($variable eq "DATE"){
            ($year,$mon,$mday) = split('\+',$value);
            last;
        }
    }
}

$year   =int($year);
$mon    =int($mon);
$mday   =int($mday);

if($year<1999 || $year>2030 || $mon<1 || $mon>12){
    $mon = $thismon;
    $year = $thisyear;
}

if(($mon == $thismon)&&($mday==0 || $mday==99)){
    $mday = $today;
}


###########################################################################
#月初日の曜日を求める(0:SUN 1:MON...)
#  localtime()が返す $wday だと、任意の年月の曜日が取得できないので
#  getweek()サブルーチンを使っている。
$wday = &getweek($year, $mon);
@weekday=("SUN","MON","TUE","WED","THU","FRI","SAT");


###########################################################################
#その月の日数を求める
$lastday = 31;
if($mon==2){
    if(($year % 400)==0){
        $lastday = 29;
    }elsif(($year % 100)==0){
        $lastday = 28;
    }elsif(($year % 4)==0){
        $lastday = 29;
    }else{
        $lastday = 28;
    }
}else{
    if($mon==4 || $mon==6 ||$mon==9 ||$mon==11){
        $lastday = 30;
    }
}


###########################################################################
#メンバー表の読み込み
open(MEMBER,"member.txt") || die "Open error :$!\n";

@memberlist=<MEMBER>;
@membername;        #メンバー名の配列
@memberpfix;        #メンバーのデータファイルプリフィックスの配列

close MEMBER;

$membercount=0;
foreach $eachmember(@memberlist){
    chomp($eachmember);                   #行末の改行の削除
    @rowdata=split(',',$eachmember);
    if(($rowdata[0] =~ /^\s*$/)||($rowdata[1] =~ /^\s*$/)){  #空白データが見つかったら終了
        last;
    }
    $membername[$membercount]=$rowdata[0];
    $memberpfix[$membercount]=$rowdata[1];
#    printf("%d:%s --> %s,%s\n",$membercount,$eachmember,$rowdata[0],$rowdata[1]);   #DEBUGPRINT
    $membercount = $membercount+1;
}


###########################################################################
#メンバーのデータの読み込み
@scheduledata;


for($i=0;$i<$membercount;$i++){
    $datfilename = sprintf("%s%04d%02d.txt",$memberpfix[$i],$year,$mon);
    $d=0;
    if(open(DATFILE,$datfilename)){
        @dat=<DATFILE>;
        close DATFILE;
        foreach $eachdat(@dat){
            if($d == $lastday){
                last;
               }
            chomp($eachdat);
            if($eachdat eq ""){
                #$eachdat="&nbsp;";
                $eachdat=" ";
               }
            $scheduledata[$i][$d]=$eachdat;
            $d++;
        }
    }
    while($d < $lastday){
        $scheduledata[$i][$d]=" ";
        $d++;
    }
}


###########################################################################
#表の幅の算出
$tablewidth=1;
for($i=0;$i<$membercount;$i++){
    if(($i%4)==0){
        $tablewidth +=($width_date+1);
    }
    $tablewidth +=($width_schedule+1);
}

###########################################################################
#前の月  次の月へのリンク文字列の作成
$y = $year;
$prevm = $mon-1;
if($prevm<1){
    $prevm = 12;
    $y--;
}
$prevmonlink = sprintf("%s?DATE=%d+%d+99",$thiscginame,$y,$prevm);
$y = $year;
$nextm = $mon+1;
if($nextm>12){
    $nextm = 1;
    $y++;
}
$nextmonlink = sprintf("%s?DATE=%d+%d+99",$thiscginame,$y,$nextm);

print <<EOF;
content-type: text/html

<HTML>
<HEAD>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=UTF-8">
<TITLE>Schedule Viewer</TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFFF">
<FONT SIZE="+2"><B>$year年$mon月スケジュール表</B></FONT>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$prevmonlink">$prevm月</A>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$nextmonlink">$nextm月</A>
&nbsp;&nbsp;&nbsp;&nbsp;
<A HREF="$todaycginame">今日のスケジュール</A>
<BR>
<BR>
<TABLE BORDER="1" CELLSPACING="0" WIDTH="$tablewidth" style="table-layout: fixed">
EOF

$w = $wday;
for($d=0;$d < $lastday;$d++){
    # 7日ごとに名前行を挿入する
    if(($d % 7)==0){
        print "<TR>\n";
        for($i=0;$i<$membercount;$i++){
            if(($i%4)==0){
                printf ("<TD WIDTH=\"%s\" bgcolor=\"%s\">&nbsp;</TD>\n",$width_date,$color_name_bg);
            }
            printf ("<TD WIDTH=\"%s\" ALIGN=\"CENTER\" bgcolor=\"%s\"><FONT color=\"%s\">",$width_schedule,$color_name_bg,$color_name_fg);
            printf ("<A HREF=\"inputdat.cgi?PFIX=%s&DATE=%d+%d+%d\">",$memberpfix[$i],$year,$mon,$d+1);
            printf ("<B>%s</B>",$membername[$i]);
            printf ("</A>");
            printf ("</FONT></TD>\n");
        }
        print "</TR>\n";
    }
    
    
    # 日付セルの色設定
    if($w == 0){
        $col_d_fg = $color_sun_fg;
        $col_d_bg = $color_sun_bg;
    }elsif($w == 6){
        $col_d_fg = $color_sat_fg;
        $col_d_bg = $color_sat_bg;
    }else{
        $col_d_fg = $color_wday_fg;
        $col_d_bg = $color_wday_bg;
    }
    # データセルの色設定
    if(($d+1)==$mday){
        $col_fg = $color_today_fg;
        $col_bg = $color_today_bg;
    }else{
        $col_fg = "#000000";
        $col_bg = "#FFFFFF";
    }
    
    print("<TR>\n");
    for($i=0;$i<$membercount;$i++){
        if(($i%4)==0){
            printf("<TD ALIGN=\"CENTER\" bgcolor=\"%s\"><FONT color=\"%s\">",$col_d_bg,$col_d_fg);
            printf("<B>%d</B><BR><SMALL>%s</SMALL></TD>\n",$d+1,$weekday[$w]);
            #printf("</FONT></TD>\n");
        }
        printf ("<TD ALIGN=\"LEFT\"");
        if($col_bg ne "#FFFFFF"){
            printf(" bgcolor=\"%s\"",$col_bg);
        }
        printf (">");


        if($col_fg ne "#000000"){
            printf ("<FONT color=\"%s\">",$col_fg);
        }
        $celldata =$scheduledata[$i][$d];
        $celldata =~ s/&/&amp;/g;           #「&」を「&amp;」に置換
        $celldata =~ s/</&lt;/g;            #「<」を「&lt;」に置換
        $celldata =~ s/>/&gt;/g;            #「>」を「&gt;」に置換
        $celldata =~ s/\s/&nbsp;/g;         # 空白文字を「&nbsp;」に置換
        $celldata =~ s/\\\\/\a/g;           #「\\」をいったん「アラーム文字」に置換 (通常の文中では使われない文字として)
        $celldata =~ s/\\n/<BR>\\r/g;       #「\n」を「<BR>\r」に置換
        @celllines = split(/\\r/,$celldata);
        foreach $eachcellline(@celllines){
            $eachcellline =~ s/\a/\\/g;             #「アラーム文字」を「\」に置換
            printf ("%s",$eachcellline);
          }
        if($col_fg ne "#000000"){
            printf ("</FONT>");
          }
        printf ("</TD>\n");
    }
    print "</TR>\n";

    $w++;
    if($w > 6){
        $w = 0;
    }
}

print <<EOF;

</TABLE>
</BODY>
</HTML>
EOF

exit(0);


##############################################################
# 月初の曜日を得る関数
# 下記 WEBページに掲載されていたものを使わせていただきました。
# http://www.tt.rim.or.jp/~canada/comp/cgi/tech/
sub getweek{
    my($year, $month) = @_;
    if ($month == 1 || $month == 2) {
        $year--;
        $month += 12;
    }
    int(
          $year
        + int($year/4)
        - int($year/100)
        + int($year/400)
        + int((13*$month+8)/5)
        + 1
    ) % 7;
}

